/*******************************************************************************/
/****                       PEDIDOS / EXPEDIO                             ****/
/*******************************************************************************/

/* Tabela PEDIDO: Cadastro de Pedidos */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela PEDIDO */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Pedidos de Produto(Cadastro de Pedidos),
             utilizando a tabela Geral de Logs de Operaes */
/* @c:\web_605\sql\end_conv\oracle\02BA_GERTRGO_LOG_PED_PEDIDO.SQL */             
             
CREATE OR REPLACE TRIGGER LOG_PED_PEDIDO
AFTER DELETE OR INSERT OR UPDATE
ON PEDIDO FOR EACH ROW
DECLARE
  V_USUARIO       VARCHAR2(40);
  V_TIPO          VARCHAR2(1);
  V_ITPESQ        VARCHAR2(40);
  V_DESC          VARCHAR2(300);
  V_CDFILLOGOPER  VARCHAR2(4);
  V_STSITPED      VARCHAR2(2);
  V_DTOPER        DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_STSITPED := '';
   V_DESC     := '';
   V_TIPO     := '0';
   V_CDFILLOGOPER := '';

   NMUSUARIO(V_USUARIO);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF NOT V_USUARIO IS NULL THEN
      IF DELETING  THEN
         V_TIPO := '3';

         V_DESC   := 'Filial '      || :OLD.CDFILIAL          || ' ' ||
                     'Pedido '      || :OLD.NRPEDIDO          || ' ' ||
                     'Dt. Pedido '  || TO_CHAR(:OLD.DTPEDIDO) || ' ' ||
                     'Cliente '     || :OLD.CDCLIENTE         || ' ' ||
                     'Vendedor '    || :OLD.CDVENDEDOR        || ' ' ||
                     'Mod. Pgto '   || :OLD.CDMODPGTO         || ' ' ||
                     'Preo Base '  || :OLD.CDPRECOBASE;

         IF :OLD.IDSITPEDIDO = '1' THEN V_STSITPED := 'PE'; END IF;
         IF :OLD.IDSITPEDIDO = '2' THEN V_STSITPED := 'AN'; END IF;
         IF :OLD.IDSITPEDIDO = '3' THEN V_STSITPED := 'LQ'; END IF;
         IF :OLD.IDSITPEDIDO = '4' THEN V_STSITPED := 'CN'; END IF;
         IF :OLD.IDSITPEDIDO = '5' THEN V_STSITPED := 'LQ'; END IF;
         IF :OLD.IDSITPEDIDO = '6' THEN V_STSITPED := 'PA'; END IF;

         IF (V_STSITPED <> '') THEN
            V_DESC := V_DESC || ' Situao ' || V_STSITPED;
         END IF;

         V_ITPESQ  := :OLD.CDFILIAL||:OLD.NRPEDIDO;
         V_CDFILLOGOPER := :OLD.CDFILIAL;
      ELSE
         IF UPDATING THEN
            V_DESC := 'Filial '      || :OLD.CDFILIAL          || ' ' ||
                      'Pedido '      || :OLD.NRPEDIDO;

            IF (:OLD.DTPEDIDO     <> :NEW.DTPEDIDO)      OR
               (:OLD.CDCLIENTE    <> :NEW.CDCLIENTE)     OR
               (:OLD.CDVENDEDOR   <> :NEW.CDVENDEDOR)    OR
               (:OLD.CDMODPGTO    <> :NEW.CDMODPGTO)     OR
               (:OLD.CDPRECOBASE  <> :NEW.CDPRECOBASE)   OR
               (:OLD.IDSITPEDIDO  <> :NEW.IDSITPEDIDO)   OR
               (:OLD.CDFILIALPED  <> :NEW.CDFILIALPED)   OR (:NEW.CDFILIALPED IS NOT NULL)  OR
               (:OLD.CDTIPOOPER   <> :NEW.CDTIPOOPER)    OR (:NEW.CDTIPOOPER IS NOT NULL)   OR
               (:OLD.IDTIPOPEDIDO <> :NEW.IDTIPOPEDIDO)  OR
               (:OLD.DTENTPED     <> :NEW.DTENTPED)      OR
               (:OLD.DTVALIPED    <> :NEW.DTVALIPED)     OR (:NEW.DTVALIPED IS NOT NULL)    OR
               (:OLD.VRPBRUVOLPED <> :NEW.VRPBRUVOLPED)  OR
               (:OLD.VRPLIQVOLPED <> :NEW.VRPLIQVOLPED)  THEN
                V_DESC := V_DESC || ' Alterado:';
                V_TIPO := '2';
            END IF;

            IF :OLD.DTPEDIDO <> :NEW.DTPEDIDO THEN
               V_DESC := V_DESC || ' Dt. Pedido ' || TO_CHAR(:OLD.DTPEDIDO);
            END IF;
            IF :OLD.CDCLIENTE <> :NEW.CDCLIENTE THEN
               V_DESC := V_DESC || ' Cliente ' || :OLD.CDCLIENTE;
            END IF;
            IF :OLD.CDVENDEDOR <> :NEW.CDVENDEDOR THEN
               V_DESC := V_DESC || ' Vendedor ' || :OLD.CDVENDEDOR;
            END IF;
            IF :OLD.CDMODPGTO <> :NEW.CDMODPGTO THEN
               V_DESC := V_DESC || ' Mod. Pgto. ' || :OLD.CDMODPGTO;
            END IF;
            IF :OLD.CDPRECOBASE <> :NEW.CDPRECOBASE THEN
               V_DESC := V_DESC || ' Preo Base ' || :OLD.CDPRECOBASE;
            END IF;
            IF :OLD.IDSITPEDIDO <> :NEW.IDSITPEDIDO THEN
               IF :OLD.IDSITPEDIDO = '1' THEN V_STSITPED := 'PE'; END IF;
               IF :OLD.IDSITPEDIDO = '2' THEN V_STSITPED := 'AN'; END IF;
               IF :OLD.IDSITPEDIDO = '3' THEN V_STSITPED := 'LQ'; END IF;
               IF :OLD.IDSITPEDIDO = '4' THEN V_STSITPED := 'CN'; END IF;
               IF :OLD.IDSITPEDIDO = '5' THEN V_STSITPED := 'LQ'; END IF;
               IF :OLD.IDSITPEDIDO = '6' THEN V_STSITPED := 'PA'; END IF;

               V_DESC := V_DESC || ' Situao ' || V_STSITPED;
            END IF;
            IF (:OLD.CDFILIALPED IS NULL) AND
               (:NEW.CDFILIALPED IS NOT NULL) THEN
               V_DESC := V_DESC || ' Filial Dest. NULL';
            ELSE
               IF (:OLD.CDFILIALPED <> :NEW.CDFILIALPED) THEN
                  V_DESC := V_DESC || ' Filial Dest. ' || :OLD.CDFILIALPED;
               END IF;
            END IF;
            IF (:OLD.CDTIPOOPER IS NULL) AND
               (:NEW.CDTIPOOPER IS NOT NULL) THEN
               V_DESC := V_DESC || ' Tipo Operao NULL';
            ELSE
               IF (:OLD.CDTIPOOPER <> :NEW.CDTIPOOPER) THEN
                  V_DESC := V_DESC || ' Tipo Operao ' || :OLD.CDTIPOOPER;
               END IF;
            END IF;
            IF :OLD.IDTIPOPEDIDO <> :NEW.IDTIPOPEDIDO THEN
               V_DESC := V_DESC || ' Tipo ' || :OLD.IDTIPOPEDIDO;
            END IF;
            IF :OLD.DTENTPED <> :NEW.DTENTPED THEN
               V_DESC := V_DESC || ' Dt. Entrega ' || TO_CHAR(:OLD.DTENTPED);
            END IF;
            IF (:OLD.DTVALIPED IS NULL) AND
               (:NEW.DTVALIPED IS NOT NULL) THEN
               V_DESC := V_DESC || ' Dt. Validade NULL' ;
            ELSE
               IF (:OLD.DTVALIPED <> :NEW.DTVALIPED) THEN
                  V_DESC := V_DESC || ' Dt. Validade ' || :OLD.DTVALIPED;
               END IF;
            END IF;
            IF (:OLD.VRPBRUVOLPED IS NULL) AND
               (:NEW.VRPBRUVOLPED IS NOT NULL) THEN
               V_DESC := V_DESC || ' Peso Bruto NULL' ;
            ELSE
               IF (:OLD.VRPBRUVOLPED <> :NEW.VRPBRUVOLPED) THEN
                  V_DESC := V_DESC || ' Peso Bruto ' || TO_CHAR(ROUND(:OLD.VRPBRUVOLPED, 5));
               END IF;
            END IF;
            IF (:OLD.VRPLIQVOLPED IS NULL) AND
               (:NEW.VRPLIQVOLPED IS NOT NULL) THEN
               V_DESC := V_DESC || ' Peso Lquido NULL' ;
            ELSE
               IF (:OLD.VRPLIQVOLPED <> :NEW.VRPLIQVOLPED) THEN
                  V_DESC := V_DESC || ' Peso Lquido ' || TO_CHAR(ROUND(:OLD.VRPLIQVOLPED, 5));
               END IF;
            END IF;

            IF (NVL(:OLD.CDROTATRANSPED,'*'))<>(NVL(:NEW.CDROTATRANSPED, '*')) THEN
               V_DESC := V_DESC || ' Rota de Entrega ' || :OLD.CDROTATRANSPED;
            END IF;

            V_CDFILLOGOPER := :OLD.CDFILIAL;
            V_ITPESQ := :OLD.CDFILIAL||:OLD.NRPEDIDO;
         ELSE
            V_TIPO   := '1';
            V_DESC   := 'Filial '      || :NEW.CDFILIAL          || ' ' ||
                        'Pedido '      || :NEW.NRPEDIDO          || ' ' ||
                        'Dt. Pedido '  || TO_CHAR(:NEW.DTPEDIDO) || ' ' ||
                        'Cliente '     || :NEW.CDCLIENTE         || ' ' ||
                        'Vendedor '    || :NEW.CDVENDEDOR        || ' ' ||
                        'Mod. Pgto '   || :NEW.CDMODPGTO         || ' ' ||
                        'Preo Base '  || :NEW.CDPRECOBASE;
            V_ITPESQ := :NEW.CDFILIAL||:NEW.NRPEDIDO;
            V_CDFILLOGOPER := :NEW.CDFILIAL;
         END IF;
      END IF;

      IF V_TIPO <> '0' THEN
         IF NOT V_DESC IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO, CDFILLOGOPER,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('PEDIDO', V_DTOPER, V_USUARIO,
                V_TIPO,   V_ITPESQ, V_DESC, V_CDFILLOGOPER,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_PED_PEDIDO','5.07.000'); END;
/

